"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getValueForDisplayName = exports.getDisplayNameForValue = exports.getOptionObjectFromValue = void 0;
/**
 *
 * @param value
 * @param options
 * @internal
 */
const getOptionObjectFromValue = (value, options) => {
    if (value)
        return options.find((opt) => opt.value === value);
};
exports.getOptionObjectFromValue = getOptionObjectFromValue;
/**
 *
 * @param value
 * @param options
 * @internal
 */
const getDisplayNameForValue = (value, options) => {
    return value
        ? (0, exports.getOptionObjectFromValue)(value, options)?.displayName ?? value
        : '';
};
exports.getDisplayNameForValue = getDisplayNameForValue;
/**
 *
 * @param value
 * @param options
 * @internal
 */
const getValueForDisplayName = (displayName, options) => {
    return displayName
        ? options.find((opt) => opt.displayName === displayName)?.value ??
            displayName
        : '';
};
exports.getValueForDisplayName = getValueForDisplayName;
//# sourceMappingURL=OptionObjectUtils.js.map