import React from 'react';
import type { Signal } from './signal-popover';
declare const SIGNALS: readonly [{
    readonly id: "aggregation-executed-without-index";
    readonly title: "Aggregation executed without index";
    readonly description: React.JSX.Element;
    readonly learnMoreLink: "https://www.mongodb.com/docs/v6.0/core/data-model-operations/#indexes";
    readonly primaryActionButtonLabel: "Create index";
    readonly primaryActionButtonIcon: "Plus";
}, {
    readonly id: "atlas-text-regex-usage-in-view";
    readonly title: "Alternate text search options available";
    readonly description: "In many cases, Atlas Search is MongoDB's most efficient full text search option. Convert your view’s query to $search for a wider range of functionality.";
    readonly learnMoreLink: "https://www.mongodb.com/docs/atlas/atlas-search/best-practices/";
    readonly primaryActionButtonLink: "https://www.mongodb.com/cloud/atlas/lp/search-1";
    readonly primaryActionButtonLabel: "Try Atlas Search";
}, {
    readonly id: "non-atlas-text-regex-usage-in-view";
    readonly title: "Alternate text search options available";
    readonly description: "In many cases, Atlas Search is MongoDB's most efficient full text search option. Connect with Atlas to explore the power of Atlas Search.";
    readonly learnMoreLink: "https://www.mongodb.com/docs/atlas/atlas-search/best-practices/";
    readonly primaryActionButtonLink: "https://www.mongodb.com/cloud/atlas/lp/search-1";
    readonly primaryActionButtonLabel: "Try Atlas Search";
}, {
    readonly id: "lookup-in-view";
    readonly title: "$lookup usage";
    readonly description: "$lookup operations can be resource-intensive because they perform operations on two collections instead of one. In certain situations, embedding documents or arrays can enhance read performance.";
    readonly learnMoreLink: "https://www.mongodb.com/docs/atlas/schema-suggestions/reduce-lookup-operations/#std-label-anti-pattern-denormalization";
}, {
    readonly id: "atlas-with-search-text-regex-usage-in-stage";
    readonly title: "Alternate text search options available";
    readonly description: "In many cases, Atlas Search is MongoDB's most efficient full text search option. Convert your query to $search for a wider range of functionality.";
    readonly learnMoreLink: "https://www.mongodb.com/docs/atlas/atlas-search/best-practices/";
    readonly primaryActionButtonLabel: "Create Search Index";
}, {
    readonly id: "atlas-without-search-text-regex-usage-in-stage";
    readonly title: "Alternate text search options available";
    readonly description: "In many cases, Atlas Search is MongoDB's most efficient full text search option. Convert your query to $search for a wider range of functionality.";
    readonly learnMoreLink: "https://www.mongodb.com/docs/atlas/atlas-search/best-practices/";
    readonly primaryActionButtonLink: "https://www.mongodb.com/cloud/atlas/lp/search-1";
    readonly primaryActionButtonLabel: "Try Atlas Search";
}, {
    readonly id: "non-atlas-text-regex-usage-in-stage";
    readonly title: "Alternate text search options available";
    readonly description: "In many cases, Atlas Search is MongoDB's most efficient full text search option. Connect with Atlas to explore the power of Atlas Search.";
    readonly learnMoreLink: "https://www.mongodb.com/docs/atlas/atlas-search/best-practices/";
    readonly primaryActionButtonLink: "https://www.mongodb.com/cloud/atlas/lp/search-1";
    readonly primaryActionButtonLabel: "Try Atlas Search";
}, {
    readonly id: "lookup-in-stage";
    readonly title: "$lookup usage";
    readonly description: "$lookup operations can be resource-intensive because they perform operations on two collections instead of one. In certain situations, embedding documents or arrays can enhance read performance.";
    readonly learnMoreLink: "https://www.mongodb.com/docs/atlas/schema-suggestions/reduce-lookup-operations/#std-label-anti-pattern-denormalization";
}, {
    readonly id: "query-executed-without-index";
    readonly title: "Query executed without index";
    readonly description: React.JSX.Element;
    readonly learnMoreLink: "https://www.mongodb.com/docs/v6.0/core/data-model-operations/#indexes";
    readonly primaryActionButtonLabel: "Create index";
    readonly primaryActionButtonIcon: "Plus";
}, {
    readonly id: "atlas-text-regex-usage-in-query";
    readonly title: "Alternate text search options available";
    readonly description: "In many cases, Atlas Search is MongoDB's most efficient full text search option. Convert your query to $search for a wider range of functionality.";
    readonly learnMoreLink: "https://www.mongodb.com/cloud/atlas/lp/search-1";
    readonly primaryActionButtonLabel: "Create Search index";
}, {
    readonly id: "bloated-document";
    readonly title: "Possibly bloated document";
    readonly description: "Large documents can slow down queries by decreasing the number of documents that can be stored in RAM. Consider breaking up your data into more collections with smaller documents, and using references to consolidate the data you need.";
    readonly learnMoreLink: "https://www.mongodb.com/docs/atlas/schema-suggestions/reduce-document-size/";
}, {
    readonly id: "explain-plan-without-index";
    readonly title: "Query executed without index";
    readonly description: React.JSX.Element;
    readonly learnMoreLink: "https://www.mongodb.com/docs/v6.0/core/data-model-operations/#indexes";
    readonly primaryActionButtonLabel: "Create index";
    readonly primaryActionButtonIcon: "Plus";
}, {
    readonly id: "too-many-indexes";
    readonly title: "High number of indexes on collection";
    readonly description: "Consider reviewing your indexes to remove any that are unnecessary. Learn more about this anti-pattern";
    readonly learnMoreLink: "https://www.mongodb.com/docs/manual/core/data-model-operations/#indexes";
}, {
    readonly id: "too-many-collections";
    readonly title: "Databases with too many collections";
    readonly description: "An excessive number of collections and their associated indexes can drain resources and impact your database's performance. In general, try to limit your replica set to 10,000 collections.";
    readonly learnMoreLink: "https://www.mongodb.com/docs/v6.0/core/data-model-operations/#large-number-of-collections";
}, {
    readonly id: "unbound-array";
    readonly title: "Large array detected";
    readonly description: "As arrays get larger, queries and indexes on that array field become less efficient. Ensure your arrays are bounded to maintain optimal query performance.";
    readonly learnMoreLink: "https://www.mongodb.com/docs/atlas/schema-suggestions/avoid-unbounded-arrays/";
}];
export declare const PerformanceSignals: {
    get(key: (typeof SIGNALS)[number]['id']): Pick<Signal, keyof (typeof SIGNALS)[number]>;
};
export {};
//# sourceMappingURL=signals.d.ts.map