/// <reference types="react" />
/**
 * React useState, but the value is persisted in Web API compatible Storage and
 * initial state is picked up from Storage if exists
 *
 * @param id storage key
 * @param initialValue initial value to use if one is not available
 * @param storage
 * @returns
 */
declare function usePersistedState<S>(id: string, initialValue: S | (() => S), storage?: Storage): readonly [S, import("react").Dispatch<import("react").SetStateAction<S>>];
export { usePersistedState };
//# sourceMappingURL=use-persisted-state.d.ts.map